/* Copyright (c) 1997-1999 Miller Puckette.
* For information on usage and redistribution, and for a DISCLAIMER OF ALL
* WARRANTIES, see the file, "LICENSE.txt," in this distribution.

iemlib written by Thomas Musil (c) IEM KUG Graz Austria 2000 */

#ifdef NT
#pragma warning( disable : 4244 )
#pragma warning( disable : 4305 )
#endif

#ifndef  PD_VERSION_MINOR
#define PD_VERSION_MINOR 32
#endif

#include "m_pd.h"
#include "g_canvas.h"
#include <math.h>
#include <stdio.h>
#include <string.h>
#include "include/iemlib.h"
#include "include/iemgui.h"


#include "iemgui/bng.c"
#include "iemgui/toggle.c"
#include "iemgui/vslider.c"
#include "iemgui/hslider.c"
#include "iemgui/vu.c"
#include "iemgui/my_canvas.c"
#include "iemgui/radiobut.c"


static t_class *iemgguuii_class;

static void *iemgguuii_new(void)
{
    t_object *x = (t_object *)pd_new(iemgguuii_class);
    post("iemgui library loaded!");
    return (x);
}

void iemgguuii_setup(void)
{
    iemgguuii_class = class_new(gensym("iemgui"), iemgguuii_new, 0,
    	sizeof(t_object), CLASS_NOINLET, 0);
}

/* ------------------------ setup routine ------------------------- */

void iemgui_setup(void)
{
    bng_setup();
    toggle_setup();
    vslider_setup();
    hslider_setup();
    vu_setup();
    my_canvas_setup();
    radiobut_setup();
    iemgguuii_setup();
}
