/* --------------- bng     gui-bang ------------------------- */

t_widgetbehavior bng_widgetbehavior;
static t_class *bng_class;

typedef struct _bng
{
     t_object x_obj;
     t_glist *x_glist;
     int      x_size;
     int      x_ldx;
     int      x_ldy;
     char     x_font[16];
     int      x_fontsize;
     int      x_flashed;
     int      x_fcol;
     int      x_bcol;
     int      x_lcol;
     int      x_loadinit;
     int      x_snd_able;
     int      x_rcv_able;
     int      x_selected;
     int      x_shiftdown;
     int      x_flashtime_break;
     int      x_flashtime_hold;
     t_symbol *x_snd;
     t_symbol *x_rcv;
     t_symbol *x_lab;
     t_clock *x_clock_hld;
     t_clock *x_clock_brk;
} t_bng;

/* widget helper functions */

void bng_update(t_bng *x, t_glist *glist)
{
    if(glist_isvisible(glist))
    {
	sys_vgui(".x%x.c itemconfigure %xBUT -fill %s\n", glist_getcanvas(glist), x,
		 iem_gui_color_str[x->x_flashed?x->x_fcol:x->x_bcol]);
    }
}

void bng_draw(t_bng *x, t_glist *glist, int firsttime)
{
    t_canvas *canvas=glist_getcanvas(glist);

    if(firsttime)/* bang-rect + bang-circ */
    {
	sys_vgui(".x%x.c create rectangle %d %d %d %d -fill %s -tags %xBASE\n",
		 canvas, x->x_obj.te_xpos, x->x_obj.te_ypos,
		 x->x_obj.te_xpos + x->x_size, x->x_obj.te_ypos + x->x_size,
		 iem_gui_color_str[x->x_bcol], x);
	sys_vgui(".x%x.c create oval %d %d %d %d -fill %s -tags %xBUT\n",
		 canvas, x->x_obj.te_xpos+1, x->x_obj.te_ypos+1,
		 x->x_obj.te_xpos + x->x_size-1, x->x_obj.te_ypos + x->x_size-1,
		 iem_gui_color_str[x->x_flashed?x->x_fcol:x->x_bcol], x);
        if(!strcmp(x->x_lab->s_name, "empty"))
	    sys_vgui(".x%x.c create text %d %d -text {%s} -anchor w \
		     -font {%s %d bold} -fill %s -tags %xLABEL\n",
		     canvas, x->x_obj.te_xpos+x->x_ldx, x->x_obj.te_ypos+x->x_ldy,
		     "", x->x_font, x->x_fontsize,
		     iem_gui_color_str[x->x_lcol], x);
        else
            sys_vgui(".x%x.c create text %d %d -text {%s} -anchor w \
		     -font {%s %d bold} -fill %s -tags %xLABEL\n",
		     canvas, x->x_obj.te_xpos+x->x_ldx, x->x_obj.te_ypos+x->x_ldy,
		     x->x_lab->s_name, x->x_font, x->x_fontsize,
		     iem_gui_color_str[x->x_lcol], x);
        sys_vgui(".x%x.c create rectangle %d %d %d %d -tags %xOUT%d\n",
		 canvas, x->x_obj.te_xpos,
		 x->x_obj.te_ypos + x->x_size-1, x->x_obj.te_xpos + IOWIDTH,
		 x->x_obj.te_ypos + x->x_size, x, 0);
        sys_vgui(".x%x.c create rectangle %d %d %d %d -tags %xIN%d\n",
		 canvas, x->x_obj.te_xpos, x->x_obj.te_ypos,
		 x->x_obj.te_xpos + IOWIDTH, x->x_obj.te_ypos+1, x, 0);
    }
    else
    {
	sys_vgui(".x%x.c coords %xBASE %d %d %d %d\n",
		 canvas, x, x->x_obj.te_xpos, x->x_obj.te_ypos,
		 x->x_obj.te_xpos + x->x_size, x->x_obj.te_ypos + x->x_size);
	sys_vgui(".x%x.c coords %xBUT %d %d %d %d\n",
		 canvas, x, x->x_obj.te_xpos+1,x->x_obj.te_ypos+1,
		 x->x_obj.te_xpos + x->x_size-1, x->x_obj.te_ypos + x->x_size-1);
        sys_vgui(".x%x.c itemconfigure %xBUT -fill %s\n", canvas, x,
		 iem_gui_color_str[x->x_flashed?x->x_fcol:x->x_bcol]);
        sys_vgui(".x%x.c coords %xLABEL %d %d\n",
		 canvas, x, x->x_obj.te_xpos+x->x_ldx, x->x_obj.te_ypos+x->x_ldy);
        sys_vgui(".x%x.c coords %xOUT%d %d %d %d %d\n",
		 canvas, x, 0, x->x_obj.te_xpos,
		 x->x_obj.te_ypos + x->x_size-1, x->x_obj.te_xpos + IOWIDTH,
		 x->x_obj.te_ypos + x->x_size);
        sys_vgui(".x%x.c coords %xIN%d %d %d %d %d\n",
		 canvas, x, 0, x->x_obj.te_xpos, x->x_obj.te_ypos,
		 x->x_obj.te_xpos + IOWIDTH, x->x_obj.te_ypos+1);
    }
}

void bng_erase(t_bng* x, t_glist* glist)
{
    t_canvas *canvas=glist_getcanvas(glist);

    sys_vgui(".x%x.c delete %xBASE\n", canvas, x);
    sys_vgui(".x%x.c delete %xBUT\n", canvas, x);
    sys_vgui(".x%x.c delete %xLABEL\n", canvas, x);
    sys_vgui(".x%x.c delete %xIN%d\n", canvas, x, 0);
    sys_vgui(".x%x.c delete %xOUT%d\n", canvas, x, 0);
}

/* ------------------------ bg widgetbehaviour----------------------------- */

static void bng_getrect(t_gobj *z, t_glist *owner, int *xp1, int *yp1, int *xp2, int *yp2)
{
    t_bng *x = (t_bng *)z;

    *xp1 = x->x_obj.te_xpos;
    *yp1 = x->x_obj.te_ypos;
    *xp2 = x->x_obj.te_xpos + x->x_size;
    *yp2 = x->x_obj.te_ypos + x->x_size;
}

static void bng_displace(t_gobj *z, t_glist *glist, int dx, int dy)
{
    t_bng *x = (t_bng *)z;

    x->x_obj.te_xpos += dx;
    x->x_obj.te_ypos += dy;
    bng_draw(x, glist, 0);
    canvas_fixlinesfor(glist_getcanvas(glist), (t_text *)x);
}

static void bng_select(t_gobj *z, t_glist *glist, int selected)
{
    t_bng *x = (t_bng *)z;
    t_canvas *canvas=glist_getcanvas(glist);

    x->x_selected = selected;
    if(selected)
    {
        pd_bind(&x->x_obj.ob_pd, iem_gui_key_sym);
        sys_vgui(".x%x.c itemconfigure %xBASE -outline %s\n", canvas, x, IEM_GUI_COLOR_SELECTED);
	sys_vgui(".x%x.c itemconfigure %xBUT -outline %s\n", canvas, x, IEM_GUI_COLOR_SELECTED);
        sys_vgui(".x%x.c itemconfigure %xLABEL -fill %s\n", canvas, x, IEM_GUI_COLOR_SELECTED);
    }
    else
    {
        pd_unbind(&x->x_obj.ob_pd, iem_gui_key_sym);
        sys_vgui(".x%x.c itemconfigure %xBASE -outline %s\n", canvas, x, IEM_GUI_COLOR_NORMAL);
	sys_vgui(".x%x.c itemconfigure %xBUT -outline %s\n", canvas, x, IEM_GUI_COLOR_NORMAL);
        sys_vgui(".x%x.c itemconfigure %xLABEL -fill %s\n", canvas, x, iem_gui_color_str[x->x_lcol]);
    }
}

static void bng_delete(t_gobj *z, t_glist *glist)
{
    t_bng *x = (t_bng *)z;

    canvas_deletelinesfor(glist_getcanvas(glist), (t_text *)z);
}

static void bng_vis(t_gobj *z, t_glist *glist, int vis)
{
    t_bng *x = (t_bng *)z;

    if(vis)
	bng_draw(x, glist, 1);
    else
	bng_erase(x, glist);
}

static void bng_save(t_gobj *z, t_binbuf *b)
{
    t_bng *x = (t_bng *)z;

    binbuf_addv(b, "ssiisiiiisssiiiiiii", gensym("#X"),gensym("obj"),
		(t_int)x->x_obj.te_xpos, (t_int)x->x_obj.te_ypos,
		gensym("bng"), x->x_size,
		x->x_flashtime_hold, x->x_flashtime_break,
		x->x_loadinit,
                x->x_snd, x->x_rcv, x->x_lab,
		x->x_ldx, x->x_ldy,
                (int)(x->x_font[0]-'a'+1)/8, x->x_fontsize,
		x->x_bcol, x->x_fcol, x->x_lcol);
    binbuf_addv(b, ";");
}

void bng_check_minmax(t_bng *x, int ftbreak, int fthold)
{
    if(ftbreak > fthold)
    {
	int h;

	h = ftbreak;
	ftbreak = fthold;
	fthold = h;
    }
    if(ftbreak < IEM_BNG_MINBREAKFLASHTIME)
	ftbreak = IEM_BNG_MINBREAKFLASHTIME;
    if(fthold < IEM_BNG_MINHOLDFLASHTIME)
        fthold = IEM_BNG_MINHOLDFLASHTIME;
    x->x_flashtime_break = ftbreak;
    x->x_flashtime_hold = fthold;
}

static void bng_properties(t_gobj *z, t_glist *owner)
{
    t_bng *x = (t_bng *)z;
    char buf[600];

    sprintf(buf, "pdtk_iemgui_dialog %%s BANG \
	    ----------dimensions(pix):----------- %g %g size: 0 0 empty \
	    --------flash-time(ms)(ms):--------- %g interrupt: %g hold: %g \
	    %g empty empty %g %g \
	    %s %s \
	    %s %g %g \
            %g %g \
	    %g %s \
            %g %s \
	    %g %s\n",
	    (float)x->x_size, (float)IEM_GUI_MINSIZE,
	    (float)x->x_flashtime_break, (float)x->x_flashtime_hold, 2.0,/*min_max_schedule+clip*/
	    -1.0, (float)x->x_loadinit, -1.0,/*no linlog, no multi*/
	    x->x_snd->s_name, x->x_rcv->s_name,
	    x->x_lab->s_name, (float)x->x_ldx, (float)x->x_ldy,
            (float)((int)(x->x_font[0]-'a'+1)/8), (float)x->x_fontsize,
            (float)x->x_bcol, iem_gui_color_str[x->x_bcol],
	    (float)x->x_fcol, iem_gui_color_str[x->x_fcol],
	    (float)x->x_lcol, iem_gui_color_str[x->x_lcol]);
    gfxstub_new(&x->x_obj.ob_pd, x, buf);
}

static void bng_bang(t_bng *x)
{
    if(x->x_flashed)
    {
	x->x_flashed = 0;
	bng_update(x, x->x_glist);
	clock_delay(x->x_clock_brk, x->x_flashtime_break);
        x->x_flashed = 1;
    }
    else
    {
	x->x_flashed = 1;
	bng_update(x, x->x_glist);
    }
    clock_delay(x->x_clock_hld, x->x_flashtime_hold);
    outlet_bang(x->x_obj.ob_outlet);
    if(x->x_snd_able && x->x_snd->s_thing)
	pd_bang(x->x_snd->s_thing);
}

static void bng_dialog(t_bng *x, t_symbol *s, int argc, t_atom *argv)
{
    t_canvas *canvas=glist_getcanvas(x->x_glist);
    int a = (int)atom_getintarg(0, argc, argv);
    int fthold = (int)atom_getintarg(2, argc, argv);
    int ftbreak = (int)atom_getintarg(3, argc, argv);
    int init = (int)atom_getintarg(5, argc, argv);
    t_symbol *snd = atom_getsymbolarg(7, argc, argv);
    t_symbol *rcv = atom_getsymbolarg(8, argc, argv);
    t_symbol *lab = atom_getsymbolarg(9, argc, argv);
    int ldx = (int)atom_getintarg(10, argc, argv);
    int ldy = (int)atom_getintarg(11, argc, argv);
    int f = (int)atom_getintarg(12, argc, argv);
    int fs = (int)atom_getintarg(13, argc, argv);
    int bcol = (int)atom_getintarg(14, argc, argv);
    int fcol = (int)atom_getintarg(15, argc, argv);
    int lcol = (int)atom_getintarg(16, argc, argv);
    int sndable=1, rcvable=1;

    if(init != 0) init = 1;
    x->x_loadinit = init;
    if(!strcmp(snd->s_name, "empty")) sndable = 0;
    if(!strcmp(rcv->s_name, "empty")) rcvable = 0;
    if(rcvable)
    {
	if(strcmp(rcv->s_name, x->x_rcv->s_name))
	{
	    if(x->x_rcv_able)
		pd_unbind(&x->x_obj.ob_pd, x->x_rcv);
            x->x_rcv = rcv;
            pd_bind(&x->x_obj.ob_pd, x->x_rcv);
	}
    }
    x->x_snd = snd;
    x->x_snd_able = sndable;
    x->x_rcv_able = rcvable;
    x->x_size = iem_gui_clip_size(a);
    bng_check_minmax(x, ftbreak, fthold);
    x->x_lcol = iem_gui_modulo_color(lcol);
    x->x_fcol = iem_gui_modulo_color(fcol);
    x->x_bcol = iem_gui_modulo_color(bcol);
    x->x_lab = lab;
    x->x_ldx = ldx;
    x->x_ldy = ldy;
    if(f == 1) strcpy(x->x_font, "helvetica");
    else if(f == 2) strcpy(x->x_font, "times");
    else strcpy(x->x_font, "courier");
    x->x_fontsize = iem_gui_clip_size(fs);

    if(!strcmp(x->x_lab->s_name, "empty"))
	sys_vgui(".x%x.c itemconfigure %xLABEL -font {%s %d bold} -fill %s -text {%s} \n",
		 canvas, x, x->x_font, x->x_fontsize,
		 x->x_selected?IEM_GUI_COLOR_SELECTED:iem_gui_color_str[x->x_lcol], "");
    else
	sys_vgui(".x%x.c itemconfigure %xLABEL -font {%s %d bold} -fill %s -text {%s} \n",
		 canvas, x, x->x_font, x->x_fontsize,
		 x->x_selected?IEM_GUI_COLOR_SELECTED:iem_gui_color_str[x->x_lcol],
		 x->x_lab->s_name);
    sys_vgui(".x%x.c itemconfigure %xBASE -fill %s\n", canvas, x,
	         iem_gui_color_str[x->x_bcol]);
    sys_vgui(".x%x.c itemconfigure %xBUT -fill %s\n", canvas, x,
	         iem_gui_color_str[x->x_flashed?x->x_fcol:x->x_bcol]);
    bng_draw(x, x->x_glist, 0);
    canvas_fixlinesfor(canvas, (t_text*)x);
}

static void bng_click(t_bng *x, t_floatarg xpos, t_floatarg ypos, t_floatarg shift, t_floatarg ctrl, t_floatarg alt)
{
    bng_bang(x);
}

#if (PD_VERSION_MINOR > 31)
static int bng_newclick(t_gobj *z, struct _glist *glist, int xpix, int ypix, int shift, int alt, int dbl, int doit)
{
    if(doit)
	bng_click((t_bng *)z, (t_floatarg)xpix, (t_floatarg)ypix, (t_floatarg)shift, 0, (t_floatarg)alt);
    return (1);
}
#endif

static void bng_float(t_bng *x, t_floatarg f)
{
    bng_bang(x);
}

static void bng_symbol(t_bng *x, t_symbol *s)
{
    bng_bang(x);
}

static void bng_pointer(t_bng *x, t_gpointer *gp)
{
    bng_bang(x);
}

static void bng_anything(t_bng *x, t_symbol *s, int argc, t_atom *argv)
{
    bng_bang(x);
}

static void bng_loadbang(t_bng *x)
{
    if(!sys_noloadbang && x->x_loadinit)
	bng_bang(x);
}

static void bng_size(t_bng *x, t_symbol *s, int ac, t_atom *av)
{
    x->x_size = iem_gui_clip_size((int)atom_getintarg(0, ac, av));
    bng_draw(x, x->x_glist, 0);
    canvas_fixlinesfor(glist_getcanvas(x->x_glist), (t_text*)x);
}

static void bng_delta(t_bng *x, t_symbol *s, int ac, t_atom *av)
{
    x->x_obj.te_xpos += (int)atom_getintarg(0, ac, av);
    x->x_obj.te_ypos += (int)atom_getintarg(1, ac, av);
    bng_draw(x, x->x_glist, 0);
    canvas_fixlinesfor(glist_getcanvas(x->x_glist), (t_text*)x);
}

static void bng_flashtime(t_bng *x, t_symbol *s, int ac, t_atom *av)
{
    bng_check_minmax(x, (int)atom_getintarg(0, ac, av),
			 (int)atom_getintarg(1, ac, av));
}

static void bng_color(t_bng *x, t_symbol *s, int ac, t_atom *av)
{
    t_canvas *canvas=glist_getcanvas(x->x_glist);

    x->x_bcol = iem_gui_modulo_color((int)atom_getintarg(0, ac, av));
    x->x_fcol = iem_gui_modulo_color((int)atom_getintarg(1, ac, av));
    x->x_lcol = iem_gui_modulo_color((int)atom_getintarg(2, ac, av));
    sys_vgui(".x%x.c itemconfigure %xLABEL -fill %s\n", canvas,
	     x, x->x_selected?IEM_GUI_COLOR_SELECTED:iem_gui_color_str[x->x_lcol]);
    sys_vgui(".x%x.c itemconfigure %xBUT -fill %s\n", canvas,
	     x, iem_gui_color_str[x->x_flashed?x->x_fcol:x->x_bcol]);
    sys_vgui(".x%x.c itemconfigure %xBASE -fill %s\n", canvas,
	     x, iem_gui_color_str[x->x_bcol]);
}

static void bng_send(t_bng *x, t_symbol *s)
{
    int sndable=1;

    if(!strcmp(s->s_name, "empty")) sndable = 0;
    x->x_snd = s;
    x->x_snd_able = sndable;
}

static void bng_receive(t_bng *x, t_symbol *s)
{
    int rcvable=1;

    if(!strcmp(s->s_name, "empty")) rcvable = 0;
    if(rcvable)
    {
	if(strcmp(s->s_name, x->x_rcv->s_name))
	{
	    if(x->x_rcv_able)
		pd_unbind(&x->x_obj.ob_pd, x->x_rcv);
            x->x_rcv = s;
            pd_bind(&x->x_obj.ob_pd, x->x_rcv);
	}
    }
    x->x_rcv_able = rcvable;
}

static void bng_label(t_bng *x, t_symbol *s)
{
    x->x_lab = s;
    if(!strcmp(s->s_name, "empty"))
	sys_vgui(".x%x.c itemconfigure %xLABEL -text {%s} \n", glist_getcanvas(x->x_glist), x, "");
    else
        sys_vgui(".x%x.c itemconfigure %xLABEL -text {%s} \n", glist_getcanvas(x->x_glist), x, s->s_name);
}

static void bng_label_pos(t_bng *x, t_symbol *s, int ac, t_atom *av)
{
    x->x_ldx = (int)atom_getintarg(0, ac, av);
    x->x_ldy = (int)atom_getintarg(1, ac, av);
    bng_draw(x, x->x_glist, 0);
}

static void bng_label_font(t_bng *x, t_symbol *s, int ac, t_atom *av)
{
    int f = (int)atom_getintarg(0, ac, av);

    if(f == 1) strcpy(x->x_font, "helvetica");
    else if(f == 2) strcpy(x->x_font, "times");
    else strcpy(x->x_font, "courier");
    x->x_fontsize = iem_gui_clip_size((int)atom_getintarg(1, ac, av));
    sys_vgui(".x%x.c itemconfigure %xLABEL -font {%s %d bold}\n",
	     glist_getcanvas(x->x_glist), x, x->x_font, x->x_fontsize);
}

static void bng_init(t_bng *x, t_floatarg f)
{
    x->x_loadinit = (f==0.0)?0:1;
}

static void bng_list(t_bng *x, t_symbol *s, int ac, t_atom *av)
{
    if(x->x_selected)
    {
	if((ac == 2)&&IS_A_FLOAT(av,0)&&IS_A_SYMBOL(av,1))
	{
	    t_symbol *key = atom_getsymbolarg(1, ac, av);
	    int keydown = atom_getintarg(0, ac, av);

	    if(keydown)
	    {
		int refresh = 1,i,d=1;
		static char buf[20];

		buf[0] = 0;
		if(!strcmp(key->s_name, "Shift_L")||!strcmp(key->s_name, "Shift_R"))
		    x->x_shiftdown = 1;
		else
		{
		    if(x->x_shiftdown)
			d = 10;

		    if(!strcmp(key->s_name, "Up"))
			x->x_obj.te_ypos -= d;
		    else if(!strcmp(key->s_name, "Down"))
			x->x_obj.te_ypos += d;
		    else if(!strcmp(key->s_name, "Left"))
			x->x_obj.te_xpos -= d;
		    else if(!strcmp(key->s_name, "Right"))
			x->x_obj.te_xpos += d;
		    else
			refresh = 0;
		    if(refresh)
		    {
			bng_draw(x, x->x_glist, 0);
			canvas_fixlinesfor(glist_getcanvas(x->x_glist), (t_text*)x);
		    }
		}
	    }
	    else
	    {
		if(!strcmp(key->s_name, "Shift_L")||!strcmp(key->s_name, "Shift_R"))
		    x->x_shiftdown = 0;
	    }
	}
	else
	    bng_bang(x);
    }
    else
	bng_bang(x);
}

static void bng_tick_hld(t_bng *x)
{
    x->x_flashed = 0;
    bng_update(x, x->x_glist);
}

static void bng_tick_brk(t_bng *x)
{
    bng_update(x, x->x_glist);
}

static void *bng_new(t_symbol *s, int argc, t_atom *argv)
{
    t_bng *x = (t_bng *)pd_new(bng_class);
    int bcol=IEM_GUI_COLNR_WHITE, fcol=IEM_GUI_COLNR_BLACK;
    int lcol=IEM_GUI_COLNR_BLACK, a=IEM_GUI_DEFAULTSIZE;
    int init=0, ldx=8, ldy=-8;
    int sndable=1, rcvable=1, f=0, fs=10;
    int ftbreak=IEM_BNG_DEFAULTBREAKFLASHTIME, fthold=IEM_BNG_DEFAULTHOLDFLASHTIME;
    t_symbol *snd = gensym("empty"), *rcv = gensym("empty"), *lab = gensym("empty");


    if((argc == 14)&&IS_A_FLOAT(argv,0)
       &&IS_A_FLOAT(argv,1)&&IS_A_FLOAT(argv,2)
       &&IS_A_FLOAT(argv,3)
       &&IS_A_SYMBOL(argv,4)&&IS_A_SYMBOL(argv,5)
       &&IS_A_SYMBOL(argv,6)&&IS_A_FLOAT(argv,7)&&IS_A_FLOAT(argv,8)
       &&IS_A_FLOAT(argv,9)&&IS_A_FLOAT(argv,10)&&IS_A_FLOAT(argv,11)
       &&IS_A_FLOAT(argv,12)&&IS_A_FLOAT(argv,13))
    {
        a = (int)atom_getintarg(0, argc, argv);
	fthold = (int)atom_getintarg(1, argc, argv);
        ftbreak = (int)atom_getintarg(2, argc, argv);
	init = (int)atom_getintarg(3, argc, argv);
        snd = atom_getsymbolarg(4, argc, argv);
	rcv = atom_getsymbolarg(5, argc, argv);
	lab = atom_getsymbolarg(6, argc, argv);
	ldx = (int)atom_getintarg(7, argc, argv);
	ldy = (int)atom_getintarg(8, argc, argv);
        f = (int)atom_getintarg(9, argc, argv);
        fs = (int)atom_getintarg(10, argc, argv);
        bcol = (int)atom_getintarg(11, argc, argv);
	fcol = (int)atom_getintarg(12, argc, argv);
        lcol = (int)atom_getintarg(13, argc, argv);
    }
    x->x_flashed = 0;
    x->x_glist = (t_glist *)canvas_getcurrent();
    if(init != 0) init = 1;
    x->x_loadinit = init;
    if(!strcmp(snd->s_name, "empty")) sndable = 0;
    if(!strcmp(rcv->s_name, "empty")) rcvable = 0;
    if(rcvable) pd_bind(&x->x_obj.ob_pd, rcv);
    x->x_snd_able = sndable;
    x->x_rcv_able = rcvable;
    x->x_snd = snd;
    x->x_rcv = rcv;
    x->x_lab = lab;
    x->x_ldx = ldx;
    x->x_ldy = ldy;
    if(f == 1) strcpy(x->x_font, "helvetica");
    else if(f == 2) strcpy(x->x_font, "times");
    else strcpy(x->x_font, "courier");
    x->x_fontsize = iem_gui_clip_size(fs);
    x->x_size = iem_gui_clip_size(a);
    bng_check_minmax(x, ftbreak, fthold);
    x->x_fcol = iem_gui_modulo_color(fcol);
    x->x_bcol = iem_gui_modulo_color(bcol);
    x->x_lcol = iem_gui_modulo_color(lcol);
    x->x_clock_hld = clock_new(x, (t_method)bng_tick_hld);
    x->x_clock_brk = clock_new(x, (t_method)bng_tick_brk);
    x->x_selected = 0;
    x->x_shiftdown = 0;
    outlet_new(&x->x_obj, &s_bang);
    return (x);
}

static void bng_ff(t_bng *x)
{
    if(x->x_selected)
        pd_unbind(&x->x_obj.ob_pd, iem_gui_key_sym);
    if(x->x_rcv_able)
	pd_unbind(&x->x_obj.ob_pd, x->x_rcv);
    clock_free(x->x_clock_brk);
    clock_free(x->x_clock_hld);
}

void bng_setup(void)
{
    bng_class = class_new(gensym("bng"), (t_newmethod)bng_new,
			  (t_method)bng_ff, sizeof(t_bng), 0, A_GIMME, 0);
    class_addbang(bng_class, bng_bang);
    class_addfloat(bng_class, bng_float);
    class_addsymbol(bng_class, bng_symbol);
    class_addpointer(bng_class, bng_pointer);
    class_addlist(bng_class, bng_list);
    class_addanything(bng_class, bng_anything);
    class_addmethod(bng_class, (t_method)bng_click, gensym("click"),
		    A_FLOAT, A_FLOAT, A_FLOAT, A_FLOAT, A_FLOAT, 0);
    class_addmethod(bng_class, (t_method)bng_dialog, gensym("dialog"),
		    A_GIMME, 0);
    class_addmethod(bng_class, (t_method)bng_loadbang, gensym("loadbang"), 0);
    class_addmethod(bng_class, (t_method)bng_size, gensym("size"), A_GIMME, 0);
    class_addmethod(bng_class, (t_method)bng_delta, gensym("delta"), A_GIMME, 0);
    class_addmethod(bng_class, (t_method)bng_flashtime, gensym("flashtime"), A_GIMME, 0);
    class_addmethod(bng_class, (t_method)bng_color, gensym("color"), A_GIMME, 0);
    class_addmethod(bng_class, (t_method)bng_send, gensym("send"), A_DEFSYM, 0);
    class_addmethod(bng_class, (t_method)bng_receive, gensym("receive"), A_DEFSYM, 0);
    class_addmethod(bng_class, (t_method)bng_label, gensym("label"), A_DEFSYM, 0);
    class_addmethod(bng_class, (t_method)bng_label_pos, gensym("label_pos"), A_GIMME, 0);
    class_addmethod(bng_class, (t_method)bng_label_font, gensym("label_font"), A_GIMME, 0);
    class_addmethod(bng_class, (t_method)bng_init, gensym("init"), A_FLOAT, 0);
    if(!iem_gui_key_sym)
	iem_gui_key_sym = gensym("#keyname");
    bng_widgetbehavior.w_getrectfn = bng_getrect;
    bng_widgetbehavior.w_displacefn = bng_displace;
    bng_widgetbehavior.w_selectfn = bng_select;
    bng_widgetbehavior.w_activatefn = NULL;
    bng_widgetbehavior.w_deletefn = bng_delete;
    bng_widgetbehavior.w_visfn = bng_vis;
#if (PD_VERSION_MINOR > 31)
    bng_widgetbehavior.w_clickfn = bng_newclick;
    bng_widgetbehavior.w_propertiesfn = bng_properties;
#endif
    bng_widgetbehavior.w_savefn = bng_save;
    class_setwidget(bng_class, &bng_widgetbehavior);
    class_sethelpsymbol(bng_class, gensym("iemhelp/help-bng"));
}
